/*
 * This file is generated by jOOQ.
 */
package com.alkemy.sophia.api.sophiamsinvoice.dbmodel.jooq.tables;


import com.alkemy.sophia.api.sophiamsinvoice.dbmodel.jooq.DefaultSchema;
import com.alkemy.sophia.api.sophiamsinvoice.dbmodel.jooq.Indexes;
import com.alkemy.sophia.api.sophiamsinvoice.dbmodel.jooq.Keys;
import com.alkemy.sophia.api.sophiamsinvoice.dbmodel.jooq.tables.records.MmRipartizione_648Record;

import java.math.BigDecimal;
import java.sql.Timestamp;
import java.util.Arrays;
import java.util.List;

import javax.annotation.Generated;

import org.jooq.Field;
import org.jooq.ForeignKey;
import org.jooq.Identity;
import org.jooq.Index;
import org.jooq.Name;
import org.jooq.Record;
import org.jooq.Schema;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@Generated(
    value = {
        "http://www.jooq.org",
        "jOOQ version:3.11.9"
    },
    comments = "This class is generated by jOOQ"
)
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class MmRipartizione_648 extends TableImpl<MmRipartizione_648Record> {

    private static final long serialVersionUID = -856726442;

    /**
     * The reference instance of <code>MM_RIPARTIZIONE_648</code>
     */
    public static final MmRipartizione_648 MM_RIPARTIZIONE_648 = new MmRipartizione_648();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<MmRipartizione_648Record> getRecordType() {
        return MmRipartizione_648Record.class;
    }

    /**
     * The column <code>MM_RIPARTIZIONE_648.ID</code>.
     */
    public final TableField<MmRipartizione_648Record, Long> ID = createField("ID", org.jooq.impl.SQLDataType.BIGINT.nullable(false).identity(true), this, "");

    /**
     * The column <code>MM_RIPARTIZIONE_648.ID_RIPARTIZIONE_SIADA</code>.
     */
    public final TableField<MmRipartizione_648Record, Integer> ID_RIPARTIZIONE_SIADA = createField("ID_RIPARTIZIONE_SIADA", org.jooq.impl.SQLDataType.INTEGER.nullable(false), this, "");

    /**
     * The column <code>MM_RIPARTIZIONE_648.DATA_ORA_CREAZIONE</code>.
     */
    public final TableField<MmRipartizione_648Record, Timestamp> DATA_ORA_CREAZIONE = createField("DATA_ORA_CREAZIONE", org.jooq.impl.SQLDataType.TIMESTAMP.nullable(false).defaultValue(org.jooq.impl.DSL.field("CURRENT_TIMESTAMP", org.jooq.impl.SQLDataType.TIMESTAMP)), this, "");

    /**
     * The column <code>MM_RIPARTIZIONE_648.ID_SOCIETA_TUTELA</code>.
     */
    public final TableField<MmRipartizione_648Record, Integer> ID_SOCIETA_TUTELA = createField("ID_SOCIETA_TUTELA", org.jooq.impl.SQLDataType.INTEGER.nullable(false), this, "");

    /**
     * The column <code>MM_RIPARTIZIONE_648.ID_CCID_METADATA</code>.
     */
    public final TableField<MmRipartizione_648Record, String> ID_CCID_METADATA = createField("ID_CCID_METADATA", org.jooq.impl.SQLDataType.VARCHAR(1024).nullable(false), this, "");

    /**
     * The column <code>MM_RIPARTIZIONE_648.VALORE_LORDO</code>.
     */
    public final TableField<MmRipartizione_648Record, BigDecimal> VALORE_LORDO = createField("VALORE_LORDO", org.jooq.impl.SQLDataType.DECIMAL(32, 20).nullable(false), this, "");

    /**
     * The column <code>MM_RIPARTIZIONE_648.VALORE_AGGIO_DEM</code>.
     */
    public final TableField<MmRipartizione_648Record, BigDecimal> VALORE_AGGIO_DEM = createField("VALORE_AGGIO_DEM", org.jooq.impl.SQLDataType.DECIMAL(32, 20).nullable(false), this, "");

    /**
     * The column <code>MM_RIPARTIZIONE_648.VALORE_AGGIO_DRM</code>.
     */
    public final TableField<MmRipartizione_648Record, BigDecimal> VALORE_AGGIO_DRM = createField("VALORE_AGGIO_DRM", org.jooq.impl.SQLDataType.DECIMAL(32, 20).nullable(false), this, "");

    /**
     * The column <code>MM_RIPARTIZIONE_648.VALORE_TRATTENUTA</code>.
     */
    public final TableField<MmRipartizione_648Record, BigDecimal> VALORE_TRATTENUTA = createField("VALORE_TRATTENUTA", org.jooq.impl.SQLDataType.DECIMAL(32, 20).nullable(false), this, "");

    /**
     * The column <code>MM_RIPARTIZIONE_648.VALORE_NETTO</code>.
     */
    public final TableField<MmRipartizione_648Record, BigDecimal> VALORE_NETTO = createField("VALORE_NETTO", org.jooq.impl.SQLDataType.DECIMAL(32, 20).nullable(false), this, "");

    /**
     * The column <code>MM_RIPARTIZIONE_648.PATH_S3_648</code>.
     */
    public final TableField<MmRipartizione_648Record, String> PATH_S3_648 = createField("PATH_S3_648", org.jooq.impl.SQLDataType.VARCHAR(1024).nullable(false), this, "");

    /**
     * The column <code>MM_RIPARTIZIONE_648.NUMERO_FATTURA</code>.
     */
    public final TableField<MmRipartizione_648Record, String> NUMERO_FATTURA = createField("NUMERO_FATTURA", org.jooq.impl.SQLDataType.VARCHAR(256).nullable(false), this, "");

    /**
     * Create a <code>MM_RIPARTIZIONE_648</code> table reference
     */
    public MmRipartizione_648() {
        this(DSL.name("MM_RIPARTIZIONE_648"), null);
    }

    /**
     * Create an aliased <code>MM_RIPARTIZIONE_648</code> table reference
     */
    public MmRipartizione_648(String alias) {
        this(DSL.name(alias), MM_RIPARTIZIONE_648);
    }

    /**
     * Create an aliased <code>MM_RIPARTIZIONE_648</code> table reference
     */
    public MmRipartizione_648(Name alias) {
        this(alias, MM_RIPARTIZIONE_648);
    }

    private MmRipartizione_648(Name alias, Table<MmRipartizione_648Record> aliased) {
        this(alias, aliased, null);
    }

    private MmRipartizione_648(Name alias, Table<MmRipartizione_648Record> aliased, Field<?>[] parameters) {
        super(alias, null, aliased, parameters, DSL.comment(""));
    }

    public <O extends Record> MmRipartizione_648(Table<O> child, ForeignKey<O, MmRipartizione_648Record> key) {
        super(child, key, MM_RIPARTIZIONE_648);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Schema getSchema() {
        return DefaultSchema.DEFAULT_SCHEMA;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public List<Index> getIndexes() {
        return Arrays.<Index>asList(Indexes.MM_RIPARTIZIONE_648_MM_RIPARTIZIONE_648_ID_SOCIETA_TUTELA_FK, Indexes.MM_RIPARTIZIONE_648_MM_RIPARTIZIONE_648_ID_UINDEX, Indexes.MM_RIPARTIZIONE_648_PRIMARY);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Identity<MmRipartizione_648Record, Long> getIdentity() {
        return Keys.IDENTITY_MM_RIPARTIZIONE_648;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public UniqueKey<MmRipartizione_648Record> getPrimaryKey() {
        return Keys.KEY_MM_RIPARTIZIONE_648_PRIMARY;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public List<UniqueKey<MmRipartizione_648Record>> getKeys() {
        return Arrays.<UniqueKey<MmRipartizione_648Record>>asList(Keys.KEY_MM_RIPARTIZIONE_648_PRIMARY, Keys.KEY_MM_RIPARTIZIONE_648_MM_RIPARTIZIONE_648_ID_UINDEX);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public List<ForeignKey<MmRipartizione_648Record, ?>> getReferences() {
        return Arrays.<ForeignKey<MmRipartizione_648Record, ?>>asList(Keys.MM_RIPARTIZIONE_648_ID_SOCIETA_TUTELA_FK);
    }

    public SocietaTutela societaTutela() {
        return new SocietaTutela(this, Keys.MM_RIPARTIZIONE_648_ID_SOCIETA_TUTELA_FK);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public MmRipartizione_648 as(String alias) {
        return new MmRipartizione_648(DSL.name(alias), this);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public MmRipartizione_648 as(Name alias) {
        return new MmRipartizione_648(alias, this);
    }

    /**
     * Rename this table
     */
    @Override
    public MmRipartizione_648 rename(String name) {
        return new MmRipartizione_648(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public MmRipartizione_648 rename(Name name) {
        return new MmRipartizione_648(name, null);
    }
}
